
/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL.CPP                                      E13 */
/*                                                                       */
/* .                                                                     */
/*************************************************************************/

#include "stdafx.h"
#include "tavr_project_loader.h"

using namespace ecg;
using namespace std;

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::actionTable
/* 
/*************************************************************************/
const TAVR_PROJECT_LOADER_IMPL::ACTION TAVR_PROJECT_LOADER_IMPL::actionTable[STATE_COUNT][TERM_COUNT] = {
	{ {}, {}, {}, {}, { AUTO_T::REDUCE, 0}, { AUTO_T::REDUCE, 0}, {}, {}, {}, },
	{ {}, {}, {}, {}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, {}, {}, {}, },
	{ {}, {}, {}, {}, {}, {}, {}, {}, {}, },
	{ {}, {}, {}, {}, { AUTO_T::SHIFT, 4 }, { AUTO_T::SHIFT, 5 }, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 6}, {}, { AUTO_T::REDUCE, 6}, { AUTO_T::REDUCE, 6}, {}, {}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 7}, {}, { AUTO_T::REDUCE, 7}, { AUTO_T::REDUCE, 7}, {}, {}, {}, {}, {}, },
	{ {}, { AUTO_T::REDUCE, 2}, {}, {}, { AUTO_T::REDUCE, 2}, { AUTO_T::REDUCE, 2}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 8}, {}, { AUTO_T::SHIFT, 8 }, {}, {}, {}, {}, {}, {}, },
	{ {}, {}, {}, {}, { AUTO_T::SHIFT, 4 }, { AUTO_T::SHIFT, 5 }, {}, {}, {}, },
	{ { AUTO_T::SHIFT, 11 }, {}, {}, {}, {}, {}, {}, {}, {}, },
	{ {}, {}, {}, { AUTO_T::SHIFT, 12 }, {}, {}, {}, {}, {}, },
	{ {}, { AUTO_T::REDUCE, 1}, {}, {}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, {}, {}, {}, },
	{ {}, { AUTO_T::REDUCE, 5}, {}, {}, { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 5}, {}, {}, {}, },
	{ {}, { AUTO_T::SHIFT, 14 }, {}, {}, { AUTO_T::SHIFT, 4 }, { AUTO_T::SHIFT, 5 }, {}, {}, {}, },
	{ {}, { AUTO_T::REDUCE, 4}, {}, {}, { AUTO_T::REDUCE, 4}, { AUTO_T::REDUCE, 4}, {}, {}, {}, },
};

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::actionTableEof
/* 
/*************************************************************************/
const TAVR_PROJECT_LOADER_IMPL::ACTION TAVR_PROJECT_LOADER_IMPL::actionTableEof[STATE_COUNT] = {
	{ AUTO_T::REDUCE, 0}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 3}, {}, {}, { AUTO_T::REDUCE, 2}, {}, {}, {}, {}, {}, { AUTO_T::REDUCE, 5}, {}, { AUTO_T::REDUCE, 4}, };

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::actionTableError
/* 
/*************************************************************************/
const TAVR_PROJECT_LOADER_IMPL::ACTION TAVR_PROJECT_LOADER_IMPL::actionTableError[STATE_COUNT] = {
	{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, };

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::productionTable
/* 
/*************************************************************************/
const int TAVR_PROJECT_LOADER_IMPL::productionTable[STATE_COUNT][NONTERM_COUNT] = {
	{ 1, -1, 2, -1, -1, -1, -1, },
	{ -1, 3, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, 6, 7, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, 9, -1, },
	{ -1, -1, -1, -1, 10, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, -1, },
	{ -1, 13, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, 6, 7, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, -1, },
};

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::procTableProduction
/* 
/*************************************************************************/
const TAVR_PROJECT_LOADER_IMPL::PRODUCTION TAVR_PROJECT_LOADER_IMPL::procTableProduction[RULE_COUNT] = {
	{ &TAVR_PROJECT_LOADER::BP, 0, 0 },
	{ NULL, 0, 1 },
	{ NULL, 2, 1 },
	{ &TAVR_PROJECT_LOADER::Project, 2, 2 },
	{ &TAVR_PROJECT_LOADER::AddSection_Impl0, 5, 3 },
	{ &TAVR_PROJECT_LOADER::AddValue_Impl0, 4, 3 },
	{ NULL, 1, 4 },
	{ &TAVR_PROJECT_LOADER::ProcessLiteral_Impl0, 1, 4 },
	{ &TAVR_PROJECT_LOADER::BS_Impl0, 0, 5 },
	{ NULL, 1, 6 },
};

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::procTableTerm
/* 
/*************************************************************************/
const TAVR_PROJECT_LOADER_IMPL::ACTION_PROC TAVR_PROJECT_LOADER_IMPL::procTableTerm[TERM_COUNT] = {
	NULL,
	NULL,
	NULL,
	NULL,
	&TAVR_PROJECT_LOADER::intPushString,
	&TAVR_PROJECT_LOADER::intPushString,
	NULL,
	NULL,
	NULL,
};

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::procTableNonterm
/* 
/*************************************************************************/
const TAVR_PROJECT_LOADER_IMPL::ACTION_PROC TAVR_PROJECT_LOADER_IMPL::procTableNonterm[NONTERM_COUNT] = {
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
};

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::TAVR_PROJECT_LOADER_IMPL()                  */
/*                                                                       */
/*************************************************************************/
TAVR_PROJECT_LOADER_IMPL::TAVR_PROJECT_LOADER_IMPL(void)
	: vstack(sizeof(VALUE_T))
{
	compilerAuto.actionTable		= &actionTable;
	compilerAuto.actionTableEof		= actionTableEof;
	compilerAuto.actionTableError	= actionTableError;
	compilerAuto.productionTable	= &productionTable;
	compilerAuto.procTableProduction = procTableProduction;
	compilerAuto.procTableTerm		= procTableTerm;
	compilerAuto.procTableNonterm	= procTableNonterm;
}

/*************************************************************************/
/* Impl()                                                                */
/*                                                                       */
/*************************************************************************/
TAVR_PROJECT_LOADER & TAVR_PROJECT_LOADER_IMPL::Impl(void)
{
	return * static_cast<IMPL_T *> (this);
}

/*************************************************************************/
/* intPushString()                                                       */
/*                                                                       */
/*************************************************************************/
void TAVR_PROJECT_LOADER_IMPL::intPushString(void)
{
	sstack.push(Impl().TokenValue());
}

/*************************************************************************/
/* intPushEmptyString()                                                  */
/*                                                                       */
/*************************************************************************/
void TAVR_PROJECT_LOADER_IMPL::intPushEmptyString(void)
{
	sstack.push(std::string());
}

/*************************************************************************/
/* intCreateStringArray()                                                */
/*                                                                       */
/*************************************************************************/
void TAVR_PROJECT_LOADER_IMPL::intCreateStringArray(void)
{
	pstack.push(new std::vector<std::string>());
	pstack.top<std::vector<std::string> >()->push_back(sstack.top());
	sstack.pop();
}

/*************************************************************************/
/* intAppendStringArray()                                                */
/*                                                                       */
/*************************************************************************/
void TAVR_PROJECT_LOADER_IMPL::intAppendStringArray(void)
{
	pstack.top<std::vector<std::string> >()->push_back(sstack.top());
	sstack.pop();
}

/*************************************************************************/
/* intCreatePtrArray()                                                   */
/*                                                                       */
/*************************************************************************/
template <class T> void TAVR_PROJECT_LOADER_IMPL::intCreatePtrArray(void)
{
	P<T> a = pstack.pop<T>();
	pstack.push(new std::vector<P<T> >());
	pstack.top<std::vector<P<T> > >()->push_back(a);
}

/*************************************************************************/
/* intAppendPtrArray()                                                   */
/*                                                                       */
/*************************************************************************/
template <class T> void TAVR_PROJECT_LOADER_IMPL::intAppendPtrArray(void)
{
	P<T> a = pstack.pop<T>();
	pstack.top<std::vector<P<T> > >()->push_back(a);
}

template <class T>
struct VALUE_TYPE_HELPER;

/*************************************************************************/
/* intCreateValArray()                                                   */
/*                                                                       */
/*************************************************************************/
template <class T> void TAVR_PROJECT_LOADER_IMPL::intCreateValArray(void)
{
	T a = VALUE_TYPE_HELPER<T>::get(vstack.top<VALUE_T>());
	vstack.pop();
	pstack.push(new std::vector<T>());
	pstack.top<std::vector<T> >()->push_back(a);
}

/*************************************************************************/
/* intAppendValArray()                                                   */
/*                                                                       */
/*************************************************************************/
template <class T> void TAVR_PROJECT_LOADER_IMPL::intAppendValArray(void)
{
	T a = VALUE_TYPE_HELPER<T>::get(vstack.top<VALUE_T>());
	vstack.pop();
	pstack.top<std::vector<T> >()->push_back(a);
}

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::AddSection_Impl0()                          */
/*                                                                       */
/*************************************************************************/
void TAVR_PROJECT_LOADER_IMPL::AddSection_Impl0(void)
{
	std::string a = sstack.top();
	sstack.pop();
	Impl().AddSection(a);
}

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::AddValue_Impl0()                            */
/*                                                                       */
/*************************************************************************/
void TAVR_PROJECT_LOADER_IMPL::AddValue_Impl0(void)
{
	std::string b = sstack.top();
	sstack.pop();
	std::string a = sstack.top();
	sstack.pop();
	Impl().AddValue(a, b);
}

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::BS_Impl0()                                  */
/*                                                                       */
/*************************************************************************/
void TAVR_PROJECT_LOADER_IMPL::BS_Impl0(void)
{
	assert(sstack.size() >= 1);
	std::string & a = sstack.c[sstack.size() - 1];
	Impl().BS(a);
}

/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::ProcessLiteral_Impl0()                      */
/*                                                                       */
/*************************************************************************/
void TAVR_PROJECT_LOADER_IMPL::ProcessLiteral_Impl0(void)
{
	std::string a = sstack.top();
	sstack.pop();
	std::string result;
	Impl().ProcessLiteral(a, result);
	sstack.push(result);
}


/*************************************************************************/
/* TAVR_PROJECT_LOADER_IMPL::Compile()                                   */
/*                                                                       */
/*************************************************************************/
void TAVR_PROJECT_LOADER_IMPL::Compile(void)
{
	compilerAuto.Compile(static_cast<IMPL_T &> (*this));
}
