#include <tavr_runtime.h>
struct Engine {
	void * __tavr_out_mouse;
	void * __tavr_out_resize;
	void * __tavr_out_update;
	__tavr_int MOUSE_ACTION_DOWN;
	__tavr_int MOUSE_ACTION_UP;
	__tavr_int MOUSE_ACTION_MOVE;
	__tavr_int MOUSE_BUTTON_LEFT;
	__tavr_int MOUSE_BUTTON_RIGHT;
	__tavr_int MOUSE_BUTTON_MIDDLE;
	__tavr_double timer;
	__tavr_float fps;
	__tavr_int fpsCounter;
	__tavr_float fpsTimer;
	__tavr_int implData;
};
void __tavr__Engine___destr_Engine(struct __tavr_ref_Engine* __tavr_this);
struct __tavr_ref_Engine {
	__tavr_int* ref;
	struct Engine* ptr;
};
void * __tavr_ti_Engine[];
void __tavr__Engine___auto(struct __tavr_ref_Engine* __tavr_this);
struct EngResize {
	__tavr_float width;
	__tavr_float height;
	__tavr_bool isReset;
};
struct __tavr_ref_EngResize {
	__tavr_int* ref;
	struct EngResize* ptr;
};
void * __tavr_ti_EngResize[];
void __tavr__EngResize___destr_EngResize(struct __tavr_ref_EngResize* __tavr_this);
void __tavr__EngResize___EngResize___float___float___bool(struct __tavr_ref_EngResize* __tavr_this, __tavr_float width, __tavr_float height, __tavr_bool isReset);
struct EngV2 {
	__tavr_float x;
	__tavr_float y;
};
struct EngMouse {
	struct __tavr_ref_Engine engine;
	__tavr_int action;
	__tavr_int button;
	struct EngV2 pos;
};
struct __tavr_ref_EngMouse {
	__tavr_int* ref;
	struct EngMouse* ptr;
};
void * __tavr_ti_EngMouse[];
void __tavr__EngMouse___destr_EngMouse(struct __tavr_ref_EngMouse* __tavr_this);
void __tavr__EngMouse___EngMouse___Engine___int___int___EngV2(struct __tavr_ref_EngMouse* __tavr_this, struct __tavr_ref_Engine engine, __tavr_int action, __tavr_int button, struct EngV2 pos);
struct System {
	__tavr_int __tavr_dummy_0;
};
void __tavr__System___destr_System(struct __tavr_ref_System* __tavr_this);
struct __tavr_ref_System {
	__tavr_int* ref;
	struct System* ptr;
};
void * __tavr_ti_System[];
__tavr_double __tavr__System___getTime2();
struct EngUpdate {
	__tavr_float time;
};
struct __tavr_ref_EngUpdate {
	__tavr_int* ref;
	struct EngUpdate* ptr;
};
void * __tavr_ti_EngUpdate[];
void __tavr__EngUpdate___destr_EngUpdate(struct __tavr_ref_EngUpdate* __tavr_this);
void __tavr__EngUpdate___EngUpdate___float(struct __tavr_ref_EngUpdate* __tavr_this, __tavr_float time);
struct EngQuad {
	__tavr_float x;
	__tavr_float y;
	__tavr_float width;
	__tavr_float height;
};
void __tavr__Engine___impl__RenderQuad___int___EngQuad_r(struct __tavr_ref_Engine* __tavr_this, __tavr_int data, struct EngQuad* quad);
void __tavr__Engine___impl__EnableBlending___int___bool(struct __tavr_ref_Engine* __tavr_this, __tavr_int data, __tavr_bool enable);
struct EngColor {
	__tavr_float r;
	__tavr_float g;
	__tavr_float b;
	__tavr_float a;
};
void __tavr__Engine___impl__Clear___int___EngColor_r(struct __tavr_ref_Engine* __tavr_this, __tavr_int data, struct EngColor* color);
struct string {
	__tavr_int length;
};
void __tavr__string___destr_string(struct __tavr_ref_string* __tavr_this);
struct __tavr_ref_string {
	__tavr_int* ref;
	struct string* ptr;
};
void * __tavr_ti_string[];
__tavr_int __tavr__Engine___impl__LoadTexture___string___int(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string path, __tavr_int implData);
void __tavr__Engine___impl__EndScene___int(struct __tavr_ref_Engine* __tavr_this, __tavr_int data);
void __tavr__Engine___impl__BeginScene___int(struct __tavr_ref_Engine* __tavr_this, __tavr_int data);
__tavr_int __tavr__Engine___impl__LoadShader___string___int___bool(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string path, __tavr_int implData, __tavr_bool isPixelShader);
void __tavr__Engine___impl__Release___int(struct __tavr_ref_Engine* __tavr_this, __tavr_int data);
void __tavr__Engine___impl__MessageLoop___int(struct __tavr_ref_Engine* __tavr_this, __tavr_int data);
__tavr_int __tavr__Engine___impl__Initialize___string___int___int(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string name, __tavr_int width, __tavr_int height);
void __tavr__EngQuad___EngQuad___float___float___float___float(struct EngQuad* __tavr_this, __tavr_float x, __tavr_float y, __tavr_float width, __tavr_float height);
struct EngTexture {
	__tavr_int implData;
	struct __tavr_ref_string name;
	__tavr_int enabledSource;
};
struct __tavr_ref_EngTexture {
	__tavr_int* ref;
	struct EngTexture* ptr;
};
void * __tavr_ti_EngTexture[];
void __tavr__EngTexture___destr_EngTexture(struct __tavr_ref_EngTexture* __tavr_this);
void __tavr__EngTexture___EngTexture___int(struct __tavr_ref_EngTexture* __tavr_this, __tavr_int implData);
struct EngShader {
	__tavr_int implData;
};
struct __tavr_ref_EngShader {
	__tavr_int* ref;
	struct EngShader* ptr;
};
void * __tavr_ti_EngShader[];
void __tavr__EngShader___destr_EngShader(struct __tavr_ref_EngShader* __tavr_this);
void __tavr__EngShader___EngShader___int(struct __tavr_ref_EngShader* __tavr_this, __tavr_int implData);
void __tavr__EngV2___EngV2(struct EngV2* __tavr_this);
void __tavr__Engine___auto(struct __tavr_ref_Engine* __tavr_this)
{
}
void __tavr__Engine___impl__OnResize___float___float___bool(struct __tavr_ref_Engine* __tavr_this, __tavr_float width, __tavr_float height, __tavr_bool isReset)
{
	__tavr_float __tavr_tmp_0;
	__tavr_float __tavr_tmp_1;
	__tavr_bool __tavr_tmp_2;
	struct __tavr_ref_EngResize __tavr_tmp_3;
	__tavr_tmp_0 = width;
	__tavr_tmp_1 = height;
	__tavr_tmp_2 = isReset;
	__tavr_tmp_3.ref = __tavr_alloc(9, __tavr_ti_EngResize);
	__tavr_tmp_3.ptr = (void*)(__tavr_tmp_3.ref+2);
	__tavr__EngResize___EngResize___float___float___bool(&__tavr_tmp_3, __tavr_tmp_0, __tavr_tmp_1, __tavr_tmp_2);
	__TAVR_INC_REF(__tavr_tmp_3);
	__tavr_out_call(__tavr_this->ptr->__tavr_out_resize, *(__tavr_ref_t*)&__tavr_tmp_3);
	__TAVR_DEC_REF(__tavr_tmp_3);
}
void __tavr__Engine___impl__OnMouse___int___int___EngV2_r(struct __tavr_ref_Engine* __tavr_this, __tavr_int action, __tavr_int button, struct EngV2* pos)
{
	struct __tavr_ref_Engine __tavr_tmp_4;
	__tavr_int __tavr_tmp_5;
	__tavr_int __tavr_tmp_6;
	struct EngV2 __tavr_tmp_7;
	struct __tavr_ref_EngMouse __tavr_tmp_8;
	__tavr_tmp_4 = (*__tavr_this);
	__TAVR_INC_REF(__tavr_tmp_4);
	__tavr_tmp_5 = action;
	__tavr_tmp_6 = button;
	__tavr_tmp_7 = (*pos);
	__tavr_tmp_8.ref = __tavr_alloc(24, __tavr_ti_EngMouse);
	__tavr_tmp_8.ptr = (void*)(__tavr_tmp_8.ref+2);
	__tavr__EngMouse___EngMouse___Engine___int___int___EngV2(&__tavr_tmp_8, __tavr_tmp_4, __tavr_tmp_5, __tavr_tmp_6, __tavr_tmp_7);
	__TAVR_INC_REF(__tavr_tmp_8);
	__tavr_out_call(__tavr_this->ptr->__tavr_out_mouse, *(__tavr_ref_t*)&__tavr_tmp_8);
	__TAVR_DEC_REF(__tavr_tmp_8);
}
void __tavr__Engine___impl__OnIdle(struct __tavr_ref_Engine* __tavr_this)
{
	__tavr_double lastTimer;
	__tavr_float dt;
	struct __tavr_ref_Engine __tavr_tmp_9;
	struct __tavr_ref_Engine __tavr_tmp_10;
	__tavr_bool __tavr_tmp_11;
	__tavr_float __tavr_tmp_14;
	struct __tavr_ref_EngUpdate __tavr_tmp_15;
	__tavr_tmp_9 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
	lastTimer = __tavr_tmp_9.ptr->timer;
	__tavr_tmp_9 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
	__tavr_tmp_9.ptr->timer = __tavr__System___getTime2();
	__tavr_tmp_9 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
	dt = (__tavr_float)(__tavr_tmp_9.ptr->timer - lastTimer);
	if((dt <= 0.f))
	{
		dt = 0.00001f;
	}
	else
	{
		if((dt > 100.f))
		{
			dt = 100.f;
		}
	}
	__tavr_tmp_9 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
	++__tavr_tmp_9.ptr->fpsCounter;
	__tavr_tmp_9 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
	__tavr_tmp_10 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_10);
	__tavr_tmp_11 = (((__tavr_double)__tavr_tmp_9.ptr->fpsTimer + 1000.0) < __tavr_tmp_10.ptr->timer);
	if(__tavr_tmp_11)
	{
		struct __tavr_ref_Engine __tavr_tmp_12;
		struct __tavr_ref_Engine __tavr_tmp_13;
		__tavr_tmp_9 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
		__tavr_tmp_10 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_10);
		__tavr_tmp_12 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_12);
		__tavr_tmp_13 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_13);
		__tavr_tmp_9.ptr->fps = (((__tavr_float)__tavr_tmp_10.ptr->fpsCounter * 1000.f) / ((__tavr_float)__tavr_tmp_12.ptr->timer - __tavr_tmp_13.ptr->fpsTimer));
		__tavr_tmp_9 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
		__tavr_tmp_10 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_10);
		__tavr_tmp_9.ptr->fpsTimer = (__tavr_float)__tavr_tmp_10.ptr->timer;
		__tavr_tmp_9 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
		__tavr_tmp_9.ptr->fpsCounter = 0;
	}
	__tavr_tmp_14 = dt;
	__tavr_tmp_15.ref = __tavr_alloc(4, __tavr_ti_EngUpdate);
	__tavr_tmp_15.ptr = (void*)(__tavr_tmp_15.ref+2);
	__tavr__EngUpdate___EngUpdate___float(&__tavr_tmp_15, __tavr_tmp_14);
	__TAVR_INC_REF(__tavr_tmp_15);
	__tavr_out_call(__tavr_this->ptr->__tavr_out_update, *(__tavr_ref_t*)&__tavr_tmp_15);
	__TAVR_DEC_REF(__tavr_tmp_15);
}
void __tavr__Engine___renderQuad___float___float___float___float(struct __tavr_ref_Engine* __tavr_this, __tavr_float x, __tavr_float y, __tavr_float width, __tavr_float height)
{
	__tavr_float __tavr_tmp_16;
	__tavr_float __tavr_tmp_17;
	__tavr_float __tavr_tmp_18;
	__tavr_float __tavr_tmp_19;
	struct EngQuad __tavr_tmp_20;
	struct __tavr_ref_Engine __tavr_tmp_21;
	__tavr_int __tavr_tmp_22;
	__tavr_tmp_16 = x;
	__tavr_tmp_17 = y;
	__tavr_tmp_18 = width;
	__tavr_tmp_19 = height;
	__tavr__EngQuad___EngQuad___float___float___float___float(&__tavr_tmp_20, __tavr_tmp_16, __tavr_tmp_17, __tavr_tmp_18, __tavr_tmp_19);
	__tavr_tmp_21 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
	__tavr_tmp_22 = __tavr_tmp_21.ptr->implData;
	__tavr__Engine___impl__RenderQuad___int___EngQuad_r(&(*__tavr_this), __tavr_tmp_22, &__tavr_tmp_20);
}
void __tavr__Engine___renderQuad___EngQuad_r(struct __tavr_ref_Engine* __tavr_this, struct EngQuad* quad)
{
	struct __tavr_ref_Engine __tavr_tmp_23;
	__tavr_int __tavr_tmp_24;
	__tavr_tmp_23 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_23);
	__tavr_tmp_24 = __tavr_tmp_23.ptr->implData;
	__tavr__Engine___impl__RenderQuad___int___EngQuad_r(&(*__tavr_this), __tavr_tmp_24, &(*quad));
}
void __tavr__Engine___enableBlending___bool(struct __tavr_ref_Engine* __tavr_this, __tavr_bool enable)
{
	struct __tavr_ref_Engine __tavr_tmp_25;
	__tavr_int __tavr_tmp_26;
	__tavr_bool __tavr_tmp_27;
	__tavr_tmp_25 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_25);
	__tavr_tmp_26 = __tavr_tmp_25.ptr->implData;
	__tavr_tmp_27 = enable;
	__tavr__Engine___impl__EnableBlending___int___bool(&(*__tavr_this), __tavr_tmp_26, __tavr_tmp_27);
}
void __tavr__Engine___clear___EngColor_r(struct __tavr_ref_Engine* __tavr_this, struct EngColor* color)
{
	struct __tavr_ref_Engine __tavr_tmp_28;
	__tavr_int __tavr_tmp_29;
	__tavr_tmp_28 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_28);
	__tavr_tmp_29 = __tavr_tmp_28.ptr->implData;
	__tavr__Engine___impl__Clear___int___EngColor_r(&(*__tavr_this), __tavr_tmp_29, &(*color));
}
struct __tavr_ref_EngTexture __tavr__Engine___loadTexture___string(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string path)
{
	__tavr_int textureData;
	struct __tavr_ref_Engine __tavr_tmp_30;
	struct __tavr_ref_string __tavr_tmp_31;
	__tavr_int __tavr_tmp_32;
	struct __tavr_ref_EngTexture __tavr_tmp_33;
	struct __tavr_ref_EngTexture __tavr_tmp_34;
	__tavr_tmp_30 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_30);
	__tavr_tmp_31 = path;
	__TAVR_INC_REF(__tavr_tmp_31);
	__tavr_tmp_32 = __tavr_tmp_30.ptr->implData;
	textureData = __tavr__Engine___impl__LoadTexture___string___int(&(*__tavr_this), __tavr_tmp_31, __tavr_tmp_32);
	__tavr_tmp_32 = textureData;
	__tavr_tmp_33.ref = __tavr_alloc(16, __tavr_ti_EngTexture);
	__tavr_tmp_33.ptr = (void*)(__tavr_tmp_33.ref+2);
	__tavr__EngTexture___EngTexture___int(&__tavr_tmp_33, __tavr_tmp_32);
	__tavr_tmp_34 = __tavr_tmp_33;
	__TAVR_INC_REF(__tavr_tmp_34);
	__TAVR_DEC_REF(__tavr_tmp_33);
	__TAVR_DEC_REF(path);
	return __tavr_tmp_34;
	__TAVR_DEC_REF(path);
}
struct __tavr_ref_EngShader __tavr__Engine___loadPixelShader___string(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string path)
{
	__tavr_int shaderData;
	struct __tavr_ref_Engine __tavr_tmp_35;
	struct __tavr_ref_string __tavr_tmp_36;
	__tavr_int __tavr_tmp_37;
	__tavr_bool __tavr_tmp_38;
	struct __tavr_ref_EngShader __tavr_tmp_39;
	struct __tavr_ref_EngShader __tavr_tmp_40;
	__tavr_tmp_35 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_35);
	__tavr_tmp_36 = path;
	__TAVR_INC_REF(__tavr_tmp_36);
	__tavr_tmp_37 = __tavr_tmp_35.ptr->implData;
	__tavr_tmp_38 = 1;
	shaderData = __tavr__Engine___impl__LoadShader___string___int___bool(&(*__tavr_this), __tavr_tmp_36, __tavr_tmp_37, __tavr_tmp_38);
	__tavr_tmp_37 = shaderData;
	__tavr_tmp_39.ref = __tavr_alloc(4, __tavr_ti_EngShader);
	__tavr_tmp_39.ptr = (void*)(__tavr_tmp_39.ref+2);
	__tavr__EngShader___EngShader___int(&__tavr_tmp_39, __tavr_tmp_37);
	__tavr_tmp_40 = __tavr_tmp_39;
	__TAVR_INC_REF(__tavr_tmp_40);
	__TAVR_DEC_REF(__tavr_tmp_39);
	__TAVR_DEC_REF(path);
	return __tavr_tmp_40;
	__TAVR_DEC_REF(path);
}
struct __tavr_ref_EngShader __tavr__Engine___loadVertexShader___string(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string path)
{
	__tavr_int shaderData;
	struct __tavr_ref_Engine __tavr_tmp_41;
	struct __tavr_ref_string __tavr_tmp_42;
	__tavr_int __tavr_tmp_43;
	__tavr_bool __tavr_tmp_44;
	struct __tavr_ref_EngShader __tavr_tmp_45;
	struct __tavr_ref_EngShader __tavr_tmp_46;
	__tavr_tmp_41 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_41);
	__tavr_tmp_42 = path;
	__TAVR_INC_REF(__tavr_tmp_42);
	__tavr_tmp_43 = __tavr_tmp_41.ptr->implData;
	__tavr_tmp_44 = 0;
	shaderData = __tavr__Engine___impl__LoadShader___string___int___bool(&(*__tavr_this), __tavr_tmp_42, __tavr_tmp_43, __tavr_tmp_44);
	__tavr_tmp_43 = shaderData;
	__tavr_tmp_45.ref = __tavr_alloc(4, __tavr_ti_EngShader);
	__tavr_tmp_45.ptr = (void*)(__tavr_tmp_45.ref+2);
	__tavr__EngShader___EngShader___int(&__tavr_tmp_45, __tavr_tmp_43);
	__tavr_tmp_46 = __tavr_tmp_45;
	__TAVR_INC_REF(__tavr_tmp_46);
	__TAVR_DEC_REF(__tavr_tmp_45);
	__TAVR_DEC_REF(path);
	return __tavr_tmp_46;
	__TAVR_DEC_REF(path);
}
void __tavr__Engine___endScene(struct __tavr_ref_Engine* __tavr_this)
{
	struct __tavr_ref_Engine __tavr_tmp_47;
	__tavr_int __tavr_tmp_48;
	__tavr_tmp_47 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_47);
	__tavr_tmp_48 = __tavr_tmp_47.ptr->implData;
	__tavr__Engine___impl__EndScene___int(&(*__tavr_this), __tavr_tmp_48);
}
void __tavr__Engine___beginScene(struct __tavr_ref_Engine* __tavr_this)
{
	struct __tavr_ref_Engine __tavr_tmp_49;
	__tavr_int __tavr_tmp_50;
	__tavr_tmp_49 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_49);
	__tavr_tmp_50 = __tavr_tmp_49.ptr->implData;
	__tavr__Engine___impl__BeginScene___int(&(*__tavr_this), __tavr_tmp_50);
}
void __tavr__Engine___release(struct __tavr_ref_Engine* __tavr_this)
{
	struct __tavr_ref_Engine __tavr_tmp_51;
	__tavr_int __tavr_tmp_52;
	__tavr_tmp_51 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_51);
	__tavr_tmp_52 = __tavr_tmp_51.ptr->implData;
	__tavr__Engine___impl__Release___int(&(*__tavr_this), __tavr_tmp_52);
}
void __tavr__Engine___run(struct __tavr_ref_Engine* __tavr_this)
{
	struct __tavr_ref_Engine __tavr_tmp_53;
	__tavr_int __tavr_tmp_54;
	__tavr_tmp_53 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_53);
	__tavr_tmp_54 = __tavr_tmp_53.ptr->implData;
	__tavr__Engine___impl__MessageLoop___int(&(*__tavr_this), __tavr_tmp_54);
}
__tavr_bool __tavr__EngMouse___isMove(struct __tavr_ref_EngMouse* __tavr_this)
{
	struct __tavr_ref_EngMouse __tavr_tmp_55;
	struct __tavr_ref_EngMouse __tavr_tmp_56;
	struct __tavr_ref_Engine __tavr_tmp_57;
	__tavr_tmp_55 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_55);
	__tavr_tmp_56 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_56);
	__tavr_tmp_57 = __tavr_tmp_56.ptr->engine;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
	return (__tavr_tmp_55.ptr->action == __tavr_tmp_57.ptr->MOUSE_ACTION_MOVE);
}
__tavr_bool __tavr__EngMouse___isUp(struct __tavr_ref_EngMouse* __tavr_this)
{
	struct __tavr_ref_EngMouse __tavr_tmp_58;
	struct __tavr_ref_EngMouse __tavr_tmp_59;
	struct __tavr_ref_Engine __tavr_tmp_60;
	__tavr_tmp_58 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
	__tavr_tmp_59 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_59);
	__tavr_tmp_60 = __tavr_tmp_59.ptr->engine;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_60);
	return (__tavr_tmp_58.ptr->action == __tavr_tmp_60.ptr->MOUSE_ACTION_UP);
}
__tavr_bool __tavr__EngMouse___isDown(struct __tavr_ref_EngMouse* __tavr_this)
{
	struct __tavr_ref_EngMouse __tavr_tmp_61;
	struct __tavr_ref_EngMouse __tavr_tmp_62;
	struct __tavr_ref_Engine __tavr_tmp_63;
	__tavr_tmp_61 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_61);
	__tavr_tmp_62 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_62);
	__tavr_tmp_63 = __tavr_tmp_62.ptr->engine;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_63);
	return (__tavr_tmp_61.ptr->action == __tavr_tmp_63.ptr->MOUSE_ACTION_DOWN);
}
__tavr_bool __tavr__EngMouse___isMiddle___bool(struct __tavr_ref_EngMouse* __tavr_this, __tavr_bool isDown)
{
	struct __tavr_ref_EngMouse __tavr_tmp_64;
	struct __tavr_ref_EngMouse __tavr_tmp_65;
	struct __tavr_ref_Engine __tavr_tmp_66;
	__tavr_bool __tavr_tmp_67;
	__tavr_tmp_64 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_64);
	__tavr_tmp_65 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_65);
	__tavr_tmp_66 = __tavr_tmp_65.ptr->engine;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_66);
	__tavr_tmp_67 = (__tavr_tmp_64.ptr->button != __tavr_tmp_66.ptr->MOUSE_BUTTON_MIDDLE);
	if(__tavr_tmp_67)
	{
		return 0;
	}
	if(isDown)
	{
		__tavr_tmp_64 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_64);
		__tavr_tmp_65 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_65);
		__tavr_tmp_66 = __tavr_tmp_65.ptr->engine;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_66);
		return (__tavr_tmp_64.ptr->action == __tavr_tmp_66.ptr->MOUSE_ACTION_DOWN);
	}
	__tavr_tmp_64 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_64);
	__tavr_tmp_65 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_65);
	__tavr_tmp_66 = __tavr_tmp_65.ptr->engine;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_66);
	return (__tavr_tmp_64.ptr->action == __tavr_tmp_66.ptr->MOUSE_ACTION_UP);
}
__tavr_bool __tavr__EngMouse___isRight___bool(struct __tavr_ref_EngMouse* __tavr_this, __tavr_bool isDown)
{
	struct __tavr_ref_EngMouse __tavr_tmp_68;
	struct __tavr_ref_EngMouse __tavr_tmp_69;
	struct __tavr_ref_Engine __tavr_tmp_70;
	__tavr_bool __tavr_tmp_71;
	__tavr_tmp_68 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
	__tavr_tmp_69 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_69);
	__tavr_tmp_70 = __tavr_tmp_69.ptr->engine;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_70);
	__tavr_tmp_71 = (__tavr_tmp_68.ptr->button != __tavr_tmp_70.ptr->MOUSE_BUTTON_RIGHT);
	if(__tavr_tmp_71)
	{
		return 0;
	}
	if(isDown)
	{
		__tavr_tmp_68 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__tavr_tmp_69 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_69);
		__tavr_tmp_70 = __tavr_tmp_69.ptr->engine;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_70);
		return (__tavr_tmp_68.ptr->action == __tavr_tmp_70.ptr->MOUSE_ACTION_DOWN);
	}
	__tavr_tmp_68 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
	__tavr_tmp_69 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_69);
	__tavr_tmp_70 = __tavr_tmp_69.ptr->engine;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_70);
	return (__tavr_tmp_68.ptr->action == __tavr_tmp_70.ptr->MOUSE_ACTION_UP);
}
__tavr_bool __tavr__EngMouse___isLeft___bool(struct __tavr_ref_EngMouse* __tavr_this, __tavr_bool isDown)
{
	struct __tavr_ref_EngMouse __tavr_tmp_72;
	struct __tavr_ref_EngMouse __tavr_tmp_73;
	struct __tavr_ref_Engine __tavr_tmp_74;
	__tavr_bool __tavr_tmp_75;
	__tavr_tmp_72 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_72);
	__tavr_tmp_73 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_73);
	__tavr_tmp_74 = __tavr_tmp_73.ptr->engine;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_74);
	__tavr_tmp_75 = (__tavr_tmp_72.ptr->button != __tavr_tmp_74.ptr->MOUSE_BUTTON_LEFT);
	if(__tavr_tmp_75)
	{
		return 0;
	}
	if(isDown)
	{
		__tavr_tmp_72 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_72);
		__tavr_tmp_73 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_73);
		__tavr_tmp_74 = __tavr_tmp_73.ptr->engine;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_74);
		return (__tavr_tmp_72.ptr->action == __tavr_tmp_74.ptr->MOUSE_ACTION_DOWN);
	}
	__tavr_tmp_72 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_72);
	__tavr_tmp_73 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_73);
	__tavr_tmp_74 = __tavr_tmp_73.ptr->engine;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_74);
	return (__tavr_tmp_72.ptr->action == __tavr_tmp_74.ptr->MOUSE_ACTION_UP);
}
void __tavr__Engine___Engine___string___int___int(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string name, __tavr_int width, __tavr_int height)
{
	__tavr_this->ptr->__tavr_out_mouse = 0;
	__tavr_this->ptr->__tavr_out_resize = 0;
	__tavr_this->ptr->__tavr_out_update = 0;
	__tavr_this->ptr->MOUSE_ACTION_DOWN = 0;
	__tavr_this->ptr->MOUSE_ACTION_UP = 1;
	__tavr_this->ptr->MOUSE_ACTION_MOVE = 2;
	__tavr_this->ptr->MOUSE_BUTTON_LEFT = 0;
	__tavr_this->ptr->MOUSE_BUTTON_RIGHT = 1;
	__tavr_this->ptr->MOUSE_BUTTON_MIDDLE = 2;
	__tavr_this->ptr->timer = 0;
	__tavr_this->ptr->fps = 0;
	__tavr_this->ptr->fpsCounter = 0;
	__tavr_this->ptr->fpsTimer = 0;
	__tavr_this->ptr->implData = 0;
	{
		struct __tavr_ref_Engine __tavr_tmp_76;
		struct __tavr_ref_string __tavr_tmp_77;
		__tavr_int __tavr_tmp_78;
		__tavr_int __tavr_tmp_79;
		__tavr_tmp_76 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_76);
		__tavr_tmp_77 = name;
		__TAVR_INC_REF(__tavr_tmp_77);
		__tavr_tmp_78 = width;
		__tavr_tmp_79 = height;
		__tavr_tmp_76.ptr->implData = __tavr__Engine___impl__Initialize___string___int___int(&(*__tavr_this), __tavr_tmp_77, __tavr_tmp_78, __tavr_tmp_79);
		__tavr_tmp_76 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_76);
		__tavr_tmp_76.ptr->timer = __tavr__System___getTime2();
		__TAVR_DEC_REF(name);
	}
}
void __tavr__Engine___destr_Engine(struct __tavr_ref_Engine* __tavr_this)
{
	__tavr_release_out_list(&__tavr_this->ptr->__tavr_out_mouse);
	__tavr_release_out_list(&__tavr_this->ptr->__tavr_out_resize);
	__tavr_release_out_list(&__tavr_this->ptr->__tavr_out_update);
}
void __tavr__EngMouse___EngMouse___Engine___int___int___EngV2(struct __tavr_ref_EngMouse* __tavr_this, struct __tavr_ref_Engine engine, __tavr_int action, __tavr_int button, struct EngV2 pos)
{
	__tavr_this->ptr->pos = pos;
	__tavr_this->ptr->button = button;
	__tavr_this->ptr->action = action;
	__tavr_this->ptr->engine = engine;
	__TAVR_INC_REF(__tavr_this->ptr->engine);
	__TAVR_DEC_REF(engine);
}
void __tavr__EngMouse___destr_EngMouse(struct __tavr_ref_EngMouse* __tavr_this)
{
	__TAVR_DEC_REF(__tavr_this->ptr->engine);
}
void __tavr__EngResize___EngResize___float___float___bool(struct __tavr_ref_EngResize* __tavr_this, __tavr_float width, __tavr_float height, __tavr_bool isReset)
{
	__tavr_this->ptr->isReset = isReset;
	__tavr_this->ptr->height = height;
	__tavr_this->ptr->width = width;
}
void __tavr__EngResize___destr_EngResize(struct __tavr_ref_EngResize* __tavr_this)
{
}
void __tavr__EngUpdate___EngUpdate___float(struct __tavr_ref_EngUpdate* __tavr_this, __tavr_float time)
{
	__tavr_this->ptr->time = time;
}
void __tavr__EngUpdate___destr_EngUpdate(struct __tavr_ref_EngUpdate* __tavr_this)
{
}
