#include <tavr_runtime.h>
struct EngV2 {
	__tavr_float x;
	__tavr_float y;
};
struct EngColor {
	__tavr_float r;
	__tavr_float g;
	__tavr_float b;
	__tavr_float a;
};
struct GameBall {
	__tavr_int __tavr_relax_0;
	__tavr_byte __tavr_stack_0[88];
	struct EngV2 pos;
	struct EngV2 speed;
	__tavr_float radius;
	struct EngColor color;
};
void __tavr__GameBall___destr_GameBall(struct __tavr_ref_GameBall* __tavr_this);
struct __tavr_ref_GameBall {
	__tavr_int* ref;
	struct GameBall* ptr;
};
void * __tavr_ti_GameBall[];
void __tavr__GameBall___auto(struct __tavr_ref_GameBall* __tavr_this);
void __tavr__GameBall___auto_1(struct __tavr_ref_GameBall* __tavr_this);
struct Engine {
	void * __tavr_out_mouse;
	void * __tavr_out_resize;
	void * __tavr_out_update;
	__tavr_int MOUSE_ACTION_DOWN;
	__tavr_int MOUSE_ACTION_UP;
	__tavr_int MOUSE_ACTION_MOVE;
	__tavr_int MOUSE_BUTTON_LEFT;
	__tavr_int MOUSE_BUTTON_RIGHT;
	__tavr_int MOUSE_BUTTON_MIDDLE;
	__tavr_double timer;
	__tavr_float fps;
	__tavr_int fpsCounter;
	__tavr_float fpsTimer;
	__tavr_int implData;
};
void __tavr__Engine___destr_Engine(struct __tavr_ref_Engine* __tavr_this);
struct __tavr_ref_Engine {
	__tavr_int* ref;
	struct Engine* ptr;
};
void * __tavr_ti_Engine[];
struct EngShader {
	__tavr_int implData;
};
void __tavr__EngShader___destr_EngShader(struct __tavr_ref_EngShader* __tavr_this);
struct __tavr_ref_EngShader {
	__tavr_int* ref;
	struct EngShader* ptr;
};
void * __tavr_ti_EngShader[];
struct __tavr_array_GameBall {
	__tavr_int* ref;
	struct __tavr_ref_GameBall* ptr;
};
void * __tavr_ti_GameBall_a[];
struct Game {
	__tavr_int __tavr_relax;
	void * __tavr_out_render;
	void * __tavr_out_update;
	struct __tavr_ref_Engine engine;
	struct __tavr_ref_EngShader shaderCircle;
	struct __tavr_ref_EngShader shaderTransform;
	__tavr_float windowWidth;
	__tavr_float windowHeight;
	__tavr_float width;
	__tavr_float height;
	struct EngV2 wnd2scr;
	struct EngV2 defGravityCenter;
	struct EngV2 gravityCenter;
	__tavr_bool gravityEnable;
	__tavr_float gravityCoef;
	__tavr_float maxSpeed;
	__tavr_float maxAcceler;
	__tavr_float massCoef;
	__tavr_float rigidCoef;
	__tavr_float mergeBarrier;
	__tavr_float ballRadius;
	__tavr_float ballRadiusRangeCoef;
	__tavr_float explodeBarrier;
	__tavr_float timeFactor;
	__tavr_float changeGravTimeCoef;
	__tavr_float changeSingleGravTimeCoef;
	__tavr_int explodeBallsCount;
	__tavr_float explodeSpeed;
	__tavr_int ballsCountMax;
	__tavr_int ballsCount;
	struct __tavr_array_GameBall balls;
};
void __tavr__Game___destr_Game(struct __tavr_ref_Game* __tavr_this);
struct __tavr_ref_Game {
	__tavr_int* ref;
	struct Game* ptr;
};
void * __tavr_ti_Game[];
struct GameRender {
	struct __tavr_ref_Game game;
};
void __tavr__GameRender___destr_GameRender(struct __tavr_ref_GameRender* __tavr_this);
struct __tavr_ref_GameRender {
	__tavr_int* ref;
	struct GameRender* ptr;
};
void * __tavr_ti_GameRender[];
void __tavr__EngShader___enable(struct __tavr_ref_EngShader* __tavr_this);
struct string {
	__tavr_int length;
};
struct __tavr_ref_string {
	__tavr_int* ref;
	struct string* ptr;
};
void * __tavr_ti_string[];
void __tavr__string___destr_string(struct __tavr_ref_string* __tavr_this);
void __tavr__EngShader___set___string___EngV2_r(struct __tavr_ref_EngShader* __tavr_this, struct __tavr_ref_string name, struct EngV2* v);
void __tavr__EngShader___set___string___float(struct __tavr_ref_EngShader* __tavr_this, struct __tavr_ref_string name, __tavr_float v);
void __tavr__EngShader___set___string___EngColor_r(struct __tavr_ref_EngShader* __tavr_this, struct __tavr_ref_string name, struct EngColor* color);
void __tavr__Engine___renderQuad___float___float___float___float(struct __tavr_ref_Engine* __tavr_this, __tavr_float x, __tavr_float y, __tavr_float width, __tavr_float height);
void __tavr__EngShader___disable(struct __tavr_ref_EngShader* __tavr_this);
void __tavr__GameBall___auto_0(struct __tavr_ref_GameBall* __tavr_this);
struct GameUpdate {
	__tavr_float elapsedTime;
	struct __tavr_ref_Game game;
};
void __tavr__GameUpdate___destr_GameUpdate(struct __tavr_ref_GameUpdate* __tavr_this);
struct __tavr_ref_GameUpdate {
	__tavr_int* ref;
	struct GameUpdate* ptr;
};
void * __tavr_ti_GameUpdate[];
void __tavr__GameBall___update___Game___float(struct __tavr_ref_GameBall* __tavr_this, struct __tavr_ref_Game game, __tavr_float elapsedTime);
struct EngV2 __tavr__EngV2___sub___EngV2_r(struct EngV2* __tavr_this, struct EngV2* v);
__tavr_float __tavr__EngV2___length__2(struct EngV2* __tavr_this);
struct EngV3 {
	__tavr_float x;
	__tavr_float y;
	__tavr_float z;
};
struct EngV3 __tavr__EngColor___toV3(struct EngColor* __tavr_this);
void __tavr__EngV3___EngV3(struct EngV3* __tavr_this);
struct EngV3 __tavr__EngV3___sub___EngV3_r(struct EngV3* __tavr_this, struct EngV3* v);
__tavr_float __tavr__abs___float(__tavr_float b);
__tavr_float __tavr__max___float___float___float(__tavr_float a, __tavr_float b, __tavr_float c);
void __tavr__Game___excludeBall___GameBall(struct __tavr_ref_Game* __tavr_this, struct __tavr_ref_GameBall ball);
struct EngColor __tavr__EngBlend___float___EngColor_r___EngColor_r(__tavr_float blend, struct EngColor* a, struct EngColor* b);
struct EngV2 __tavr__EngBlend___float___EngV2_r___EngV2_r(__tavr_float blend, struct EngV2* a, struct EngV2* b);
void __tavr__EngV2___EngV2(struct EngV2* __tavr_this);
__tavr_float __tavr__sqrt___float(__tavr_float __tavr_dummy_arg_0);
__tavr_float __tavr__max___float___float(__tavr_float a, __tavr_float b);
__tavr_int __tavr__min___int___int(__tavr_int a, __tavr_int b);
void __tavr__GameBall___GameBall___Game(struct __tavr_ref_GameBall* __tavr_this, struct __tavr_ref_Game game);
__tavr_float __tavr__random();
void __tavr__EngV2___EngV2___float___float(struct EngV2* __tavr_this, __tavr_float x, __tavr_float y);
struct EngV2 __tavr__EngV2___add___EngV2_r(struct EngV2* __tavr_this, struct EngV2* v);
struct EngV2 __tavr__EngV2___length___float(struct EngV2* __tavr_this, __tavr_float val);
void __tavr__Game___includeBall___GameBall(struct __tavr_ref_Game* __tavr_this, struct __tavr_ref_GameBall ball);
struct GameChangeGravity {
	struct __tavr_ref_Game game;
	__tavr_bool enable;
	struct EngV2 pos;
};
void __tavr__GameChangeGravity___destr_GameChangeGravity(struct __tavr_ref_GameChangeGravity* __tavr_this);
struct __tavr_ref_GameChangeGravity {
	__tavr_int* ref;
	struct GameChangeGravity* ptr;
};
void * __tavr_ti_GameChangeGravity[];
__tavr_float __tavr__EngV2___length(struct EngV2* __tavr_this);
__tavr_float __tavr__min___float___float(__tavr_float a, __tavr_float b);
void __tavr__EngV2___updateAdd___EngV2_r(struct EngV2* __tavr_this, struct EngV2* v);
void __tavr__EngV2___updateLength___float(struct EngV2* __tavr_this, __tavr_float len);
struct EngV2 __tavr__EngV2___mul___float(struct EngV2* __tavr_this, __tavr_float v);
void __tavr__EngV2___updateMaxLength___float(struct EngV2* __tavr_this, __tavr_float len);
void __tavr__EngV2___updateMul___float(struct EngV2* __tavr_this, __tavr_float v);
void __tavr__EngColor___EngColor(struct EngColor* __tavr_this);
void __tavr__EngColor___EngColor___float___float___float(struct EngColor* __tavr_this, __tavr_float r, __tavr_float g, __tavr_float b);
void __tavr__GameBall___auto(struct __tavr_ref_GameBall* __tavr_this)
{
	if (__tavr_cur_event.ref != 0) {
		__tavr_ref_t __tavr_tmp_event = __tavr_cur_event;
		__tavr_add_post_layer();
		__TAVR_INC_REF(__tavr_cur_event);
		__tavr__GameBall___auto_0(__tavr_this);
		__TAVR_DEC_REF(__tavr_cur_event);
		__tavr_cur_event.ptr = __tavr_cur_event.ref = 0;
		__tavr_remove_post_layer();
		__tavr_add_post_layer();
		__tavr_cur_event = __tavr_tmp_event;
		__TAVR_INC_REF(__tavr_cur_event);
		__tavr__GameBall___auto_1(__tavr_this);
		__TAVR_DEC_REF(__tavr_cur_event);
		__tavr_cur_event.ptr = __tavr_cur_event.ref = 0;
		__tavr_remove_post_layer();
		__tavr_cur_event = __tavr_tmp_event;
	} else {
		__tavr__GameBall___auto_0(__tavr_this);
		__tavr__GameBall___auto_1(__tavr_this);
	}
	{
	}
}
void __tavr__GameBall___auto_1(struct __tavr_ref_GameBall* __tavr_this)
{
	{
		if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 4)
		{
			struct __tavr_ref_GameRender event;
			event = (*(struct __tavr_ref_GameRender*)&__tavr_cur_event);
			__TAVR_INC_REF(event);
			__TAVR_DEC_REF((*(struct __tavr_ref_GameRender*)&__tavr_cur_event));
			(*(struct __tavr_ref_GameRender*)&__tavr_cur_event).ptr = 0;
			(*(struct __tavr_ref_GameRender*)&__tavr_cur_event).ref = 0;
			{
				struct __tavr_ref_EngShader vs;
				struct __tavr_ref_EngShader ps;
				struct __tavr_ref_GameRender __tavr_tmp_0;
				struct __tavr_ref_Game __tavr_tmp_1;
				struct __tavr_ref_GameBall __tavr_tmp_2;
				struct __tavr_ref_string __tavr_tmp_3;
				struct __tavr_ref_string __tavr_tmp_4;
				struct __tavr_ref_GameBall __tavr_tmp_5;
				__tavr_float __tavr_tmp_6;
				struct __tavr_ref_GameBall __tavr_tmp_7;
				struct __tavr_ref_GameBall __tavr_tmp_8;
				struct __tavr_ref_GameBall __tavr_tmp_9;
				struct __tavr_ref_GameBall __tavr_tmp_10;
				__tavr_float __tavr_tmp_11;
				__tavr_float __tavr_tmp_12;
				__tavr_float __tavr_tmp_13;
				__tavr_tmp_0 = event;
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_0);
				__tavr_tmp_1 = __tavr_tmp_0.ptr->game;
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_1);
				vs = __tavr_tmp_1.ptr->shaderTransform;
				__TAVR_INC_REF(vs);
				__tavr_tmp_0 = event;
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_0);
				__tavr_tmp_1 = __tavr_tmp_0.ptr->game;
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_1);
				ps = __tavr_tmp_1.ptr->shaderCircle;
				__TAVR_INC_REF(ps);
				__tavr__EngShader___enable(&ps);
				__tavr_tmp_2 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_2);
				__tavr_tmp_3.ref = __tavr_alloc_string(L"center");
				__tavr_tmp_3.ptr = (void*)(__tavr_tmp_3.ref+2);
				__tavr_tmp_4 = __tavr_tmp_3;
				__TAVR_INC_REF(__tavr_tmp_4);
				__tavr__EngShader___set___string___EngV2_r(&ps, __tavr_tmp_4, &__tavr_tmp_2.ptr->pos);
				__TAVR_DEC_REF(__tavr_tmp_3);
				__tavr_tmp_2 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_2);
				__tavr_tmp_5 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_5);
				__tavr_tmp_3.ref = __tavr_alloc_string(L"radius_2");
				__tavr_tmp_3.ptr = (void*)(__tavr_tmp_3.ref+2);
				__tavr_tmp_4 = __tavr_tmp_3;
				__TAVR_INC_REF(__tavr_tmp_4);
				__tavr_tmp_6 = (__tavr_tmp_2.ptr->radius * __tavr_tmp_5.ptr->radius);
				__tavr__EngShader___set___string___float(&ps, __tavr_tmp_4, __tavr_tmp_6);
				__TAVR_DEC_REF(__tavr_tmp_3);
				__tavr_tmp_2 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_2);
				__tavr_tmp_3.ref = __tavr_alloc_string(L"color");
				__tavr_tmp_3.ptr = (void*)(__tavr_tmp_3.ref+2);
				__tavr_tmp_4 = __tavr_tmp_3;
				__TAVR_INC_REF(__tavr_tmp_4);
				__tavr__EngShader___set___string___EngColor_r(&ps, __tavr_tmp_4, &__tavr_tmp_2.ptr->color);
				__TAVR_DEC_REF(__tavr_tmp_3);
				__tavr__EngShader___enable(&vs);
				__tavr_tmp_0 = event;
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_0);
				__tavr_tmp_1 = __tavr_tmp_0.ptr->game;
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_1);
				__tavr_tmp_2 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_2);
				__tavr_tmp_5 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_5);
				__tavr_tmp_7 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_7);
				__tavr_tmp_8 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_8);
				__tavr_tmp_9 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
				__tavr_tmp_10 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_10);
				__tavr_tmp_6 = (__tavr_tmp_9.ptr->pos.x - __tavr_tmp_10.ptr->radius);
				__tavr_tmp_11 = (__tavr_tmp_7.ptr->pos.y - __tavr_tmp_8.ptr->radius);
				__tavr_tmp_12 = (2.f * __tavr_tmp_5.ptr->radius);
				__tavr_tmp_13 = (2.f * __tavr_tmp_2.ptr->radius);
				__tavr__Engine___renderQuad___float___float___float___float(&__tavr_tmp_1.ptr->engine, __tavr_tmp_6, __tavr_tmp_11, __tavr_tmp_12, __tavr_tmp_13);
				__tavr__EngShader___disable(&ps);
				__tavr__EngShader___disable(&vs);
				__TAVR_DEC_REF(ps);
				__TAVR_DEC_REF(vs);
			}
			__TAVR_DEC_REF(event);
		}
		else
		{
		}
	}
}
void __tavr__GameBall___auto_0(struct __tavr_ref_GameBall* __tavr_this)
{
	switch (__tavr_this->ptr->__tavr_relax_0) {
		__TAVR_RELAX_CASE_DEFAULT2_S(0);
		__TAVR_RELAX_CASE2_S(0, 1, __tavr_label_1);
		__TAVR_RELAX_CASE2_S(0, 2, __tavr_label_7);
		default: __TAVR_UNKNOWN_RELAX_CONTEXT(); return ;
	}
	{
		{
			if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 3)
			{
				(*(struct __tavr_ref_GameUpdate*)(__tavr_this->ptr->__tavr_stack_0+0)) = (*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event);
				__TAVR_INC_REF((*(struct __tavr_ref_GameUpdate*)(__tavr_this->ptr->__tavr_stack_0+0)));
				__TAVR_DEC_REF((*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event));
				(*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event).ptr = 0;
				(*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event).ref = 0;
				{
					struct __tavr_ref_GameUpdate __tavr_tmp_14;
					struct __tavr_ref_Game __tavr_tmp_15;
					__tavr_float __tavr_tmp_16;
					__tavr_tmp_14 = (*(struct __tavr_ref_GameUpdate*)(__tavr_this->ptr->__tavr_stack_0+0));
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_14);
					(*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8)) = __tavr_tmp_14.ptr->game;
					__TAVR_INC_REF((*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8)));
					__tavr_tmp_14 = (*(struct __tavr_ref_GameUpdate*)(__tavr_this->ptr->__tavr_stack_0+0));
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_14);
					__tavr_tmp_15 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
					__TAVR_INC_REF(__tavr_tmp_15);
					__tavr_tmp_16 = __tavr_tmp_14.ptr->elapsedTime;
					__tavr__GameBall___update___Game___float(&(*__tavr_this), __tavr_tmp_15, __tavr_tmp_16);
					{
						struct __tavr_array_GameBall __tavr_tmp_17;
						__tavr_bool __tavr_tmp_18;
						(*(__tavr_int*)(__tavr_this->ptr->__tavr_stack_0+16)) = 0;
__tavr_label_0: ;
						__tavr_tmp_15 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_15);
						__tavr_tmp_17 = __tavr_tmp_15.ptr->balls;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_17);
						__tavr_tmp_18 = ((*(__tavr_int*)(__tavr_this->ptr->__tavr_stack_0+16)) < __TAVR_ARRAY_LENGTH(__tavr_tmp_17));
						if(__tavr_tmp_18)
						{
							__tavr_int __tavr_tmp_19;
							__tavr_bool __tavr_tmp_20;
							struct __tavr_ref_GameBall __tavr_tmp_21;
							struct __tavr_ref_GameBall __tavr_tmp_22;
							struct EngV2 __tavr_tmp_23;
							struct EngV3 __tavr_tmp_24;
							__tavr_float __tavr_tmp_25;
							__tavr_float __tavr_tmp_26;
							__tavr_float __tavr_tmp_27;
							__tavr_float __tavr_tmp_28;
							__tavr_float __tavr_tmp_29;
							__tavr_tmp_15 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_15);
							__tavr_tmp_17 = __tavr_tmp_15.ptr->balls;
							__tavr_tmp_19 = (*(__tavr_int*)(__tavr_this->ptr->__tavr_stack_0+16));
							__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_17, __tavr_tmp_19);
							(*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)) = __tavr_tmp_17.ptr[__tavr_tmp_19];
							__TAVR_INC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)));
							if (((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)).ref == 0)) {
								__tavr_tmp_18 = 1;
							} else {
								__tavr_tmp_18 = ((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)).ref == (*__tavr_this).ref);
							}
							__tavr_tmp_20 = __tavr_tmp_18;
							if(__tavr_tmp_20)
							{
								__TAVR_DEC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)));
								goto __tavr_label_5;
							}
							__tavr_tmp_21 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
							__tavr_tmp_22 = (*__tavr_this);
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
							__tavr_tmp_23 = __tavr__EngV2___sub___EngV2_r(&__tavr_tmp_21.ptr->pos, &__tavr_tmp_22.ptr->pos);
							(*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+28)) = __tavr__EngV2___length__2(&__tavr_tmp_23);
							__tavr_tmp_21 = (*__tavr_this);
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
							__tavr_tmp_22 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
							(*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+32)) = (__tavr_tmp_21.ptr->radius + __tavr_tmp_22.ptr->radius);
							if((((*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+28)) + 0.001f) > ((*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+32)) * (*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+32)))))
							{
								__TAVR_DEC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)));
								goto __tavr_label_5;
							}
							__tavr_tmp_21 = (*__tavr_this);
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
							__tavr_tmp_24 = __tavr__EngColor___toV3(&__tavr_tmp_21.ptr->color);
							(*(struct EngV3*)(__tavr_this->ptr->__tavr_stack_0+36)) = __tavr_tmp_24;
							__tavr_tmp_21 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
							__tavr_tmp_24 = __tavr__EngColor___toV3(&__tavr_tmp_21.ptr->color);
							(*(struct EngV3*)(__tavr_this->ptr->__tavr_stack_0+48)) = __tavr_tmp_24;
							__tavr_tmp_24 = __tavr__EngV3___sub___EngV3_r(&(*(struct EngV3*)(__tavr_this->ptr->__tavr_stack_0+36)), &(*(struct EngV3*)(__tavr_this->ptr->__tavr_stack_0+48)));
							(*(struct EngV3*)(__tavr_this->ptr->__tavr_stack_0+60)) = __tavr_tmp_24;
							__tavr_tmp_16 = (*(struct EngV3*)(__tavr_this->ptr->__tavr_stack_0+60)).z;
							__tavr_tmp_25 = (*(struct EngV3*)(__tavr_this->ptr->__tavr_stack_0+60)).y;
							__tavr_tmp_26 = (*(struct EngV3*)(__tavr_this->ptr->__tavr_stack_0+60)).x;
							__tavr_tmp_27 = __tavr__abs___float(__tavr_tmp_26);
							__tavr_tmp_28 = __tavr__abs___float(__tavr_tmp_25);
							__tavr_tmp_29 = __tavr__abs___float(__tavr_tmp_16);
							(*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+72)) = __tavr__max___float___float___float(__tavr_tmp_27, __tavr_tmp_28, __tavr_tmp_29);
							__tavr_tmp_15 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_15);
							__tavr_tmp_18 = ((*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+72)) < __tavr_tmp_15.ptr->mergeBarrier);
							if(__tavr_tmp_18)
							{
								struct __tavr_ref_GameBall __tavr_tmp_30;
								struct __tavr_ref_GameBall __tavr_tmp_31;
								struct EngColor __tavr_tmp_32;
								__tavr_tmp_21 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
								__TAVR_INC_REF(__tavr_tmp_21);
								__tavr__Game___excludeBall___GameBall(&(*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8)), __tavr_tmp_21);
								__tavr_tmp_21 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
								__tavr_tmp_22 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
								__tavr_tmp_30 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_30);
								__tavr_tmp_31 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_31);
								(*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+76)) = ((__tavr_tmp_21.ptr->radius * __tavr_tmp_22.ptr->radius) / (__tavr_tmp_30.ptr->radius * __tavr_tmp_31.ptr->radius));
								__tavr_tmp_21 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
								__tavr_tmp_22 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
								__tavr_tmp_30 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_30);
								__tavr_tmp_16 = (*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+76));
								__tavr_tmp_32 = __tavr__EngBlend___float___EngColor_r___EngColor_r(__tavr_tmp_16, &__tavr_tmp_30.ptr->color, &__tavr_tmp_22.ptr->color);
								__tavr_tmp_21.ptr->color = __tavr_tmp_32;
								__tavr_tmp_21 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
								__tavr_tmp_22 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
								__tavr_tmp_30 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_30);
								__tavr_tmp_16 = (*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+76));
								__tavr_tmp_23 = __tavr__EngBlend___float___EngV2_r___EngV2_r(__tavr_tmp_16, &__tavr_tmp_30.ptr->pos, &__tavr_tmp_22.ptr->pos);
								__tavr_tmp_21.ptr->pos = __tavr_tmp_23;
								__tavr_tmp_21 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
								__tavr__EngV2___EngV2(&__tavr_tmp_23);
								__tavr_tmp_21.ptr->speed = __tavr_tmp_23;
								__tavr_tmp_21 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
								__tavr_tmp_22 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
								__tavr_tmp_30 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_30);
								__tavr_tmp_31 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_31);
								__tavr_tmp_16 = ((__tavr_tmp_21.ptr->radius * __tavr_tmp_22.ptr->radius) + (__tavr_tmp_30.ptr->radius * __tavr_tmp_31.ptr->radius));
								(*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+80)) = __tavr__sqrt___float(__tavr_tmp_16);
								__tavr_tmp_21 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
								__tavr_tmp_22 = (*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
								__tavr_tmp_30 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_30);
								__tavr_tmp_16 = __tavr_tmp_30.ptr->radius;
								__tavr_tmp_25 = __tavr_tmp_22.ptr->radius;
								__tavr_tmp_21.ptr->radius = __tavr__max___float___float(__tavr_tmp_16, __tavr_tmp_25);
								__tavr_tmp_21 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
								(*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+84)) = ((*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+80)) - __tavr_tmp_21.ptr->radius);
__tavr_label_1: ;
								{
									if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 3)
									{
										struct __tavr_ref_GameUpdate event;
										event = (*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event);
										__TAVR_INC_REF(event);
										__TAVR_DEC_REF((*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event));
										(*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event).ptr = 0;
										(*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event).ref = 0;
										{
											__tavr_float toAdd;
											__tavr_tmp_14 = event;
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_14);
											toAdd = ((*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+84)) * __tavr_tmp_14.ptr->elapsedTime);
											__tavr_tmp_21 = (*__tavr_this);
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
											__tavr_tmp_18 = (toAdd > ((*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+80)) - __tavr_tmp_21.ptr->radius));
											if(__tavr_tmp_18)
											{
												__tavr_tmp_21 = (*__tavr_this);
												__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
												__tavr_tmp_21.ptr->radius = (*(__tavr_float*)(__tavr_this->ptr->__tavr_stack_0+80));
												__TAVR_DEC_REF(event);
												goto __tavr_label_2;
											}
											__tavr_tmp_21 = (*__tavr_this);
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
											__tavr_tmp_22 = (*__tavr_this);
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
											__tavr_tmp_21.ptr->radius = (__tavr_tmp_22.ptr->radius + toAdd);
											__tavr_tmp_14 = event;
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_14);
											__tavr_tmp_15 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
											__TAVR_INC_REF(__tavr_tmp_15);
											__tavr_tmp_16 = __tavr_tmp_14.ptr->elapsedTime;
											__tavr__GameBall___update___Game___float(&(*__tavr_this), __tavr_tmp_15, __tavr_tmp_16);
										}
										__TAVR_DEC_REF(event);
									}
									else
									{
									}
								}
								__tavr_this->ptr->__tavr_relax_0 = 1;
								return ;
__tavr_label_2: ;
								__TAVR_DEC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)));
								goto __tavr_label_6;
							}
							__tavr_tmp_21 = (*__tavr_this);
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
							__tavr_tmp_15 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_15);
							__tavr_tmp_18 = (__tavr_tmp_21.ptr->radius > __tavr_tmp_15.ptr->explodeBarrier);
							if(__tavr_tmp_18)
							{
								__tavr_int to_create;
								struct __tavr_ref_Game __tavr_tmp_33;
								struct __tavr_ref_Game __tavr_tmp_34;
								__tavr_int __tavr_tmp_35;
								__tavr_tmp_21 = (*__tavr_this);
								__TAVR_INC_REF(__tavr_tmp_21);
								__tavr__Game___excludeBall___GameBall(&(*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8)), __tavr_tmp_21);
								__tavr_tmp_15 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_15);
								__tavr_tmp_33 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_33);
								__tavr_tmp_34 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_34);
								__tavr_tmp_19 = __tavr_tmp_34.ptr->explodeBallsCount;
								__tavr_tmp_35 = (__tavr_tmp_15.ptr->ballsCountMax - __tavr_tmp_33.ptr->ballsCount);
								to_create = __tavr__min___int___int(__tavr_tmp_19, __tavr_tmp_35);
								{
									__tavr_int k;
									k = 0;
__tavr_label_3: ;
									if((k < to_create))
									{
										struct __tavr_ref_GameBall b;
										struct __tavr_ref_GameBall __tavr_tmp_36;
										struct __tavr_ref_GameBall __tavr_tmp_37;
										struct EngV2 __tavr_tmp_38;
										__tavr_tmp_15 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
										__TAVR_INC_REF(__tavr_tmp_15);
										__tavr_tmp_21.ref = __tavr_alloc(128, __tavr_ti_GameBall);
										__tavr_tmp_21.ptr = (void*)(__tavr_tmp_21.ref+2);
										__tavr__GameBall___GameBall___Game(&__tavr_tmp_21, __tavr_tmp_15);
										b = __tavr_tmp_21;
										__TAVR_INC_REF(b);
										__TAVR_DEC_REF(__tavr_tmp_21);
										__tavr_tmp_21 = b;
										__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
										__tavr_tmp_22 = (*__tavr_this);
										__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
										__tavr_tmp_36 = (*__tavr_this);
										__TAVR_ASSERT_NULL_PTR(__tavr_tmp_36);
										__tavr_tmp_37 = (*__tavr_this);
										__TAVR_ASSERT_NULL_PTR(__tavr_tmp_37);
										__tavr_tmp_16 = (__tavr_tmp_37.ptr->radius * ((2.f * __tavr__random()) - 1.f));
										__tavr_tmp_25 = (__tavr_tmp_36.ptr->radius * ((2.f * __tavr__random()) - 1.f));
										__tavr__EngV2___EngV2___float___float(&__tavr_tmp_23, __tavr_tmp_16, __tavr_tmp_25);
										__tavr_tmp_38 = __tavr__EngV2___add___EngV2_r(&__tavr_tmp_22.ptr->pos, &__tavr_tmp_23);
										__tavr_tmp_21.ptr->pos = __tavr_tmp_38;
										__tavr_tmp_21 = b;
										__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
										__tavr_tmp_22 = b;
										__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
										__tavr_tmp_36 = (*__tavr_this);
										__TAVR_ASSERT_NULL_PTR(__tavr_tmp_36);
										__tavr_tmp_23 = __tavr__EngV2___sub___EngV2_r(&__tavr_tmp_22.ptr->pos, &__tavr_tmp_36.ptr->pos);
										__tavr_tmp_15 = (*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8));
										__TAVR_ASSERT_NULL_PTR(__tavr_tmp_15);
										__tavr_tmp_16 = __tavr_tmp_15.ptr->explodeSpeed;
										__tavr_tmp_38 = __tavr__EngV2___length___float(&__tavr_tmp_23, __tavr_tmp_16);
										__tavr_tmp_21.ptr->speed = __tavr_tmp_38;
										__tavr_tmp_21 = b;
										__TAVR_INC_REF(__tavr_tmp_21);
										__tavr__Game___includeBall___GameBall(&(*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8)), __tavr_tmp_21);
										__TAVR_DEC_REF(b);
									}
									else
									goto __tavr_label_4;
									{
										++k;
									}
									goto __tavr_label_3;
__tavr_label_4: ;
								}
								__TAVR_DEC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)));
								goto __tavr_label_6;
							}
							__TAVR_DEC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)));
						}
						else
						goto __tavr_label_6;
__tavr_label_5: ;
						{
							++(*(__tavr_int*)(__tavr_this->ptr->__tavr_stack_0+16));
						}
						goto __tavr_label_0;
__tavr_label_6: ;
					}
					__TAVR_DEC_REF((*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8)));
				}
				__TAVR_DEC_REF((*(struct __tavr_ref_GameUpdate*)(__tavr_this->ptr->__tavr_stack_0+0)));
			}
			else
			{
			}
			if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 5)
			{
				(*(struct __tavr_ref_GameChangeGravity*)(__tavr_this->ptr->__tavr_stack_0+0)) = (*(struct __tavr_ref_GameChangeGravity*)&__tavr_cur_event);
				__TAVR_INC_REF((*(struct __tavr_ref_GameChangeGravity*)(__tavr_this->ptr->__tavr_stack_0+0)));
				__TAVR_DEC_REF((*(struct __tavr_ref_GameChangeGravity*)&__tavr_cur_event));
				(*(struct __tavr_ref_GameChangeGravity*)&__tavr_cur_event).ptr = 0;
				(*(struct __tavr_ref_GameChangeGravity*)&__tavr_cur_event).ref = 0;
				{
					struct __tavr_ref_GameChangeGravity __tavr_tmp_39;
					__tavr_bool __tavr_tmp_40;
					__tavr_tmp_39 = (*(struct __tavr_ref_GameChangeGravity*)(__tavr_this->ptr->__tavr_stack_0+0));
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_39);
					__tavr_tmp_40 = (! __tavr_tmp_39.ptr->enable);
					if(__tavr_tmp_40)
					{
						__TAVR_DEC_REF((*(struct __tavr_ref_GameChangeGravity*)(__tavr_this->ptr->__tavr_stack_0+0)));
						goto __tavr_label_9;
					}
					__tavr_tmp_39 = (*(struct __tavr_ref_GameChangeGravity*)(__tavr_this->ptr->__tavr_stack_0+0));
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_39);
					(*(struct EngV2*)(__tavr_this->ptr->__tavr_stack_0+8)) = __tavr_tmp_39.ptr->pos;
__tavr_label_7: ;
					{
						if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 3)
						{
							struct __tavr_ref_GameUpdate event;
							event = (*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event);
							__TAVR_INC_REF(event);
							__TAVR_DEC_REF((*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event));
							(*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event).ptr = 0;
							(*(struct __tavr_ref_GameUpdate*)&__tavr_cur_event).ref = 0;
							{
								struct EngV2 dir;
								__tavr_float len;
								struct __tavr_ref_GameBall __tavr_tmp_41;
								struct EngV2 __tavr_tmp_42;
								__tavr_tmp_41 = (*__tavr_this);
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_41);
								__tavr_tmp_42 = __tavr__EngV2___sub___EngV2_r(&(*(struct EngV2*)(__tavr_this->ptr->__tavr_stack_0+8)), &__tavr_tmp_41.ptr->pos);
								dir = __tavr_tmp_42;
								len = __tavr__EngV2___length(&dir);
								if((len > 0.01f))
								{
									__tavr_float speedCoef;
									struct __tavr_ref_GameUpdate __tavr_tmp_43;
									struct __tavr_ref_Game __tavr_tmp_44;
									__tavr_float __tavr_tmp_45;
									__tavr_float __tavr_tmp_46;
									struct __tavr_ref_GameUpdate __tavr_tmp_47;
									__tavr_float __tavr_tmp_48;
									__tavr_tmp_43 = event;
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_43);
									__tavr_tmp_44 = __tavr_tmp_43.ptr->game;
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_44);
									__tavr_tmp_45 = (len / __tavr_tmp_44.ptr->maxSpeed);
									__tavr_tmp_46 = 1.3f;
									speedCoef = __tavr__max___float___float(__tavr_tmp_45, __tavr_tmp_46);
									__tavr_tmp_41 = (*__tavr_this);
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_41);
									__tavr_tmp_43 = event;
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_43);
									__tavr_tmp_47 = event;
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_47);
									__tavr_tmp_44 = __tavr_tmp_47.ptr->game;
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_44);
									__tavr_tmp_45 = len;
									__tavr_tmp_46 = __tavr_tmp_44.ptr->maxSpeed;
									__tavr_tmp_48 = ((speedCoef * __tavr_tmp_43.ptr->elapsedTime) * __tavr__min___float___float(__tavr_tmp_45, __tavr_tmp_46));
									__tavr_tmp_42 = __tavr__EngV2___length___float(&dir, __tavr_tmp_48);
									__tavr__EngV2___updateAdd___EngV2_r(&__tavr_tmp_41.ptr->pos, &__tavr_tmp_42);
								}
							}
							__TAVR_DEC_REF(event);
						}
						else
						{
						}
						if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 5)
						{
							struct __tavr_ref_GameChangeGravity event;
							event = (*(struct __tavr_ref_GameChangeGravity*)&__tavr_cur_event);
							__TAVR_INC_REF(event);
							__TAVR_DEC_REF((*(struct __tavr_ref_GameChangeGravity*)&__tavr_cur_event));
							(*(struct __tavr_ref_GameChangeGravity*)&__tavr_cur_event).ptr = 0;
							(*(struct __tavr_ref_GameChangeGravity*)&__tavr_cur_event).ref = 0;
							{
								__tavr_tmp_39 = event;
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_39);
								__tavr_tmp_40 = (! __tavr_tmp_39.ptr->enable);
								if(__tavr_tmp_40)
								{
									struct __tavr_ref_GameBall __tavr_tmp_49;
									struct __tavr_ref_Game __tavr_tmp_50;
									struct __tavr_ref_GameBall __tavr_tmp_51;
									struct EngV2 __tavr_tmp_52;
									struct __tavr_ref_GameChangeGravity __tavr_tmp_53;
									struct __tavr_ref_Game __tavr_tmp_54;
									__tavr_float __tavr_tmp_55;
									struct EngV2 __tavr_tmp_56;
									__tavr_tmp_49 = (*__tavr_this);
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_49);
									__tavr_tmp_39 = event;
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_39);
									__tavr_tmp_50 = __tavr_tmp_39.ptr->game;
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_50);
									__tavr_tmp_51 = (*__tavr_this);
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_51);
									__tavr_tmp_52 = __tavr__EngV2___sub___EngV2_r(&__tavr_tmp_50.ptr->gravityCenter, &__tavr_tmp_51.ptr->pos);
									__tavr_tmp_53 = event;
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_53);
									__tavr_tmp_54 = __tavr_tmp_53.ptr->game;
									__TAVR_ASSERT_NULL_PTR(__tavr_tmp_54);
									__tavr_tmp_55 = (2.f * __tavr_tmp_54.ptr->explodeSpeed);
									__tavr_tmp_56 = __tavr__EngV2___length___float(&__tavr_tmp_52, __tavr_tmp_55);
									__tavr_tmp_49.ptr->speed = __tavr_tmp_56;
									__TAVR_DEC_REF(event);
									goto __tavr_label_8;
								}
								__tavr_tmp_39 = event;
								__TAVR_ASSERT_NULL_PTR(__tavr_tmp_39);
								(*(struct EngV2*)(__tavr_this->ptr->__tavr_stack_0+8)) = __tavr_tmp_39.ptr->pos;
							}
							__TAVR_DEC_REF(event);
						}
						else
						{
						}
					}
					__tavr_this->ptr->__tavr_relax_0 = 2;
					return ;
__tavr_label_8: ;
				}
				__TAVR_DEC_REF((*(struct __tavr_ref_GameChangeGravity*)(__tavr_this->ptr->__tavr_stack_0+0)));
			}
			else
			{
			}
		}
__tavr_label_9: ;
	}
	__tavr_this->ptr->__tavr_relax_0 = 0;
}
void __tavr__GameBall___update___Game___float(struct __tavr_ref_GameBall* __tavr_this, struct __tavr_ref_Game game, __tavr_float elapsedTime)
{
	struct EngV2 acc;
	__tavr_float mass;
	struct EngV2 toGravity;
	__tavr_float speedLength;
	struct __tavr_ref_Game __tavr_tmp_57;
	struct __tavr_ref_GameBall __tavr_tmp_58;
	struct __tavr_ref_GameBall __tavr_tmp_59;
	struct EngV2 __tavr_tmp_60;
	__tavr_bool __tavr_tmp_61;
	__tavr_bool __tavr_tmp_62;
	__tavr_float __tavr_tmp_67;
	__tavr__EngV2___EngV2(&acc);
	__tavr_tmp_57 = game;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
	__tavr_tmp_58 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
	__tavr_tmp_59 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_59);
	mass = ((__tavr_tmp_57.ptr->massCoef * __tavr_tmp_58.ptr->radius) * __tavr_tmp_59.ptr->radius);
	__tavr_tmp_57 = game;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
	__tavr_tmp_58 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
	__tavr_tmp_60 = __tavr__EngV2___sub___EngV2_r(&__tavr_tmp_57.ptr->gravityCenter, &__tavr_tmp_58.ptr->pos);
	toGravity = __tavr_tmp_60;
	__tavr_tmp_57 = game;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
	if (__tavr_tmp_57.ptr->gravityEnable) {
		__tavr_tmp_61 = (__tavr__EngV2___length(&toGravity) > 0.0001f);
	} else {
		__tavr_tmp_61 = 0;
	}
	__tavr_tmp_62 = __tavr_tmp_61;
	if(__tavr_tmp_62)
	{
		__tavr_float grav;
		__tavr_float __tavr_tmp_63;
		__tavr_tmp_57 = game;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
		grav = ((mass * __tavr_tmp_57.ptr->gravityCoef) / __tavr__EngV2___length(&toGravity));
		__tavr_tmp_63 = (grav / mass);
		__tavr_tmp_60 = __tavr__EngV2___length___float(&toGravity, __tavr_tmp_63);
		__tavr__EngV2___updateAdd___EngV2_r(&acc, &__tavr_tmp_60);
	}
	{
		__tavr_int i;
		struct __tavr_array_GameBall __tavr_tmp_64;
		i = 0;
__tavr_label_10: ;
		__tavr_tmp_57 = game;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
		__tavr_tmp_64 = __tavr_tmp_57.ptr->balls;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_64);
		__tavr_tmp_61 = (i < __TAVR_ARRAY_LENGTH(__tavr_tmp_64));
		if(__tavr_tmp_61)
		{
			struct __tavr_ref_GameBall ball;
			__tavr_float dist_2;
			__tavr_float minDist;
			__tavr_float dist;
			__tavr_float power;
			struct EngV2 dir;
			__tavr_int __tavr_tmp_65;
			__tavr_float __tavr_tmp_66;
			__tavr_tmp_57 = game;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
			__tavr_tmp_64 = __tavr_tmp_57.ptr->balls;
			__tavr_tmp_65 = i;
			__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_64, __tavr_tmp_65);
			ball = __tavr_tmp_64.ptr[__tavr_tmp_65];
			__TAVR_INC_REF(ball);
			if ((ball.ref == (*__tavr_this).ref)) {
				__tavr_tmp_61 = 1;
			} else {
				__tavr_tmp_61 = (ball.ref == 0);
			}
			__tavr_tmp_62 = __tavr_tmp_61;
			if(__tavr_tmp_62)
			{
				__TAVR_DEC_REF(ball);
				goto __tavr_label_11;
			}
			__tavr_tmp_58 = ball;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
			__tavr_tmp_59 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_59);
			__tavr_tmp_60 = __tavr__EngV2___sub___EngV2_r(&__tavr_tmp_58.ptr->pos, &__tavr_tmp_59.ptr->pos);
			dist_2 = __tavr__EngV2___length__2(&__tavr_tmp_60);
			__tavr_tmp_58 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
			__tavr_tmp_59 = ball;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_59);
			minDist = (__tavr_tmp_58.ptr->radius + __tavr_tmp_59.ptr->radius);
			if(((dist_2 + 0.001f) > (minDist * minDist)))
			{
				__TAVR_DEC_REF(ball);
				goto __tavr_label_11;
			}
			__tavr_tmp_66 = dist_2;
			dist = __tavr__sqrt___float(__tavr_tmp_66);
			__tavr_tmp_57 = game;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
			power = (__tavr_tmp_57.ptr->rigidCoef * (minDist - dist));
			__tavr_tmp_58 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
			__tavr_tmp_59 = ball;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_59);
			__tavr_tmp_60 = __tavr__EngV2___sub___EngV2_r(&__tavr_tmp_58.ptr->pos, &__tavr_tmp_59.ptr->pos);
			dir = __tavr_tmp_60;
			__tavr_tmp_66 = (power / mass);
			__tavr__EngV2___updateLength___float(&dir, __tavr_tmp_66);
			__tavr_tmp_66 = elapsedTime;
			__tavr_tmp_60 = __tavr__EngV2___mul___float(&dir, __tavr_tmp_66);
			__tavr__EngV2___updateAdd___EngV2_r(&acc, &__tavr_tmp_60);
			__TAVR_DEC_REF(ball);
		}
		else
		goto __tavr_label_12;
__tavr_label_11: ;
		{
			++i;
		}
		goto __tavr_label_10;
__tavr_label_12: ;
	}
	__tavr_tmp_57 = game;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
	__tavr_tmp_67 = __tavr_tmp_57.ptr->maxAcceler;
	__tavr__EngV2___updateMaxLength___float(&acc, __tavr_tmp_67);
	__tavr_tmp_58 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
	__tavr_tmp_67 = elapsedTime;
	__tavr_tmp_60 = __tavr__EngV2___mul___float(&acc, __tavr_tmp_67);
	__tavr__EngV2___updateAdd___EngV2_r(&__tavr_tmp_58.ptr->speed, &__tavr_tmp_60);
	__tavr_tmp_58 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
	speedLength = __tavr__EngV2___length(&__tavr_tmp_58.ptr->speed);
	__tavr_tmp_57 = game;
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
	__tavr_tmp_61 = (speedLength > __tavr_tmp_57.ptr->maxSpeed);
	if(__tavr_tmp_61)
	{
		struct __tavr_ref_Game __tavr_tmp_68;
		__tavr_float __tavr_tmp_69;
		__tavr_float __tavr_tmp_70;
		__tavr_tmp_58 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
		__tavr_tmp_57 = game;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
		__tavr_tmp_68 = game;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__tavr_tmp_67 = (speedLength - __tavr_tmp_68.ptr->maxSpeed);
		__tavr_tmp_69 = (elapsedTime * __tavr_tmp_57.ptr->maxAcceler);
		__tavr_tmp_70 = ((speedLength - __tavr__min___float___float(__tavr_tmp_67, __tavr_tmp_69)) / speedLength);
		__tavr__EngV2___updateMul___float(&__tavr_tmp_58.ptr->speed, __tavr_tmp_70);
	}
	__tavr_tmp_58 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_58);
	__tavr_tmp_59 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_59);
	__tavr_tmp_67 = elapsedTime;
	__tavr_tmp_60 = __tavr__EngV2___mul___float(&__tavr_tmp_59.ptr->speed, __tavr_tmp_67);
	__tavr__EngV2___updateAdd___EngV2_r(&__tavr_tmp_58.ptr->pos, &__tavr_tmp_60);
	__TAVR_DEC_REF(game);
}
void __tavr__GameBall___GameBall___Game(struct __tavr_ref_GameBall* __tavr_this, struct __tavr_ref_Game game)
{
	__tavr_this->ptr->__tavr_relax_0 = 0;
	__tavr__EngV2___EngV2(&__tavr_this->ptr->pos);
	__tavr__EngV2___EngV2(&__tavr_this->ptr->speed);
	__tavr_this->ptr->radius = 0;
	__tavr__EngColor___EngColor(&__tavr_this->ptr->color);
	{
		struct __tavr_ref_GameBall __tavr_tmp_71;
		struct __tavr_ref_Game __tavr_tmp_72;
		struct __tavr_ref_Game __tavr_tmp_73;
		__tavr_float __tavr_tmp_74;
		__tavr_float __tavr_tmp_75;
		__tavr_float __tavr_tmp_76;
		struct EngColor __tavr_tmp_77;
		__tavr_tmp_71 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_71);
		__tavr_tmp_72 = game;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_72);
		__tavr_tmp_71.ptr->pos.x = (__tavr__random() * __tavr_tmp_72.ptr->width);
		__tavr_tmp_71 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_71);
		__tavr_tmp_72 = game;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_72);
		__tavr_tmp_71.ptr->pos.y = (__tavr__random() * __tavr_tmp_72.ptr->height);
		__tavr_tmp_71 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_71);
		__tavr_tmp_72 = game;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_72);
		__tavr_tmp_73 = game;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_73);
		__tavr_tmp_71.ptr->radius = (((__tavr_tmp_72.ptr->ballRadiusRangeCoef * __tavr__random()) + 1.f) * __tavr_tmp_73.ptr->ballRadius);
		__tavr_tmp_71 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_71);
		__tavr_tmp_74 = (0.45f + (0.45f * __tavr__random()));
		__tavr_tmp_75 = (0.15f + (0.75f * __tavr__random()));
		__tavr_tmp_76 = (0.2f + (0.7f * __tavr__random()));
		__tavr__EngColor___EngColor___float___float___float(&__tavr_tmp_77, __tavr_tmp_74, __tavr_tmp_75, __tavr_tmp_76);
		__tavr_tmp_71.ptr->color = __tavr_tmp_77;
		__TAVR_DEC_REF(game);
	}
}
void __tavr__GameBall___destr_GameBall(struct __tavr_ref_GameBall* __tavr_this)
{
	switch (__tavr_this->ptr->__tavr_relax_0) {
		case 1:
			__TAVR_DEC_REF((*(struct __tavr_ref_GameUpdate*)(__tavr_this->ptr->__tavr_stack_0+0)));
			__TAVR_DEC_REF((*(struct __tavr_ref_Game*)(__tavr_this->ptr->__tavr_stack_0+8)));
			__TAVR_DEC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack_0+20)));
			break;
		case 2:
			__TAVR_DEC_REF((*(struct __tavr_ref_GameChangeGravity*)(__tavr_this->ptr->__tavr_stack_0+0)));
			break;
		default: if (__tavr_this->ptr->__tavr_relax_0 != 0) __TAVR_UNKNOWN_RELAX_CONTEXT(); break;
	}
}
