/**
	File: main.tavr
	Description: Tavr Game.

	Copyright: Evgeniy A. Cymbalyuk, 2008
*/

struct VS_OUTPUT {
	float4 pos    : POSITION;
	float2 texPos : TEXCOORD0;
	float2 tex	  : TEXCOORD1;
};

float width;
float height;

VS_OUTPUT main(float3 pos : POSITION)
{
	VS_OUTPUT res;
	res.pos = float4(2 * pos.x / width - 1, 2 * pos.y / height - 1, 0, 1);
	res.texPos = pos.xy;
	res.tex = float2(pos.x / width, pos.y / height);
	return res;
}