
#include "stdafx.h"
#include "tavr.h"

using namespace std;

/************************************************************************/
/* main
/*
/************************************************************************/
int main(int argc, const char * argv[])
{
	if (argc != 2) {
		cout << "ERROR: please specify project name" << endl;
		cout << "USE:   tavr.exe my_project.tvrproj" << endl;
		return -1;
	}

	ifstream projFile(argv[1]);
	if (!projFile) {
		cout << "ERROR: failed to open file \"" << argv[1] << "\"" << endl;
		return -1;
	}

	tavr::PROJECT project;
	if (!project.Load(projFile)) {
		cout << "ERROR: failed to load project \"" << argv[1] << "\"" << endl;
		return -1;
	}
	
	project.Compile();

	return 0;
}